﻿
/// <summary>

/// コマンド書式を定義する。

/// 

/// clsDataFormatSimple は単純な書式で、以下のような書式である。

/// [アドレスBYTE] [コマンド番号BYTE] [ペイロードバイト列]

/// 

/// ※ 複雑なアドレスやオプションが格納されている書式拡張のため、インタフェース化している。

/// </summary>

/// <remarks></remarks>
using System.Diagnostics;
using System.Linq;
using System.Collections.Generic;
using System.Collections;
using System;
using System.Xml.Linq;

namespace MONOW_PAL_PARSER
{
    public interface ITweDataFormat
    {
        /// <summary>
    /// 書式バイト列を得る
    /// </summary>
    /// <returns></returns>
    /// <remarks></remarks>
        byte[] toByteArray();

        /// <summary>
    /// バイト列から書式オブジェクトを生成する
    /// </summary>
    /// <param name="b"></param>
    /// <returns></returns>
    /// <remarks></remarks>
        bool parseByteArray(ref byte[] b);

        /// <summary>
    /// 書式オブジェクトのタイプを得る（ダウンキャストを行うために利用）
    /// </summary>
    /// <value></value>
    /// <returns></returns>
    /// <remarks></remarks>
        byte byFormatType { get; }

        /// <summary>
    /// ペイロードオブジェクトを得る (Nothing の場合空)
    /// </summary>
    /// <value></value>
    /// <returns></returns>
    /// <remarks></remarks>
        ITweDataPayload objPayload { get; }
    }
}
